<?php if (!defined('WPINC')) die();
	
	
	
	if (!defined("UNIX_DAY"))
		define("UNIX_DAY",(24*60*60));
	
	if (!defined("UNIX_HOUR"))
		define("UNIX_HOUR",(60*60));
		
	if (!defined("UNIX_MINUTE"))
		define("UNIX_MINUTE",(60));

	
	
	/*
	 * Showing campaigns list
	 * 
	 * @global $notify, $campaigns, $splashes, $counters
	 * @return web-page
	 */
	function campaigns()
	{
		global $notify, $campaigns;
		
		// include wp table
			include_once(MEGATICKER_APPPATH.'/views/campaigns-list.php');
		
			//Create an instance of our package class...
			$listTable = new MegaTicker_Campaigns_List_Table($campaigns);
			//Fetch, prepare, sort, and filter our data...
			$listTable->prepare_items();
		
		// include main view
			include_once(MEGATICKER_APPPATH.'/views/campaigns.php');
	}


	/*
	 * Showing campaign setup form
	 * 
	 * @global $notify, $campaigns, $splashes, $counters
	 * @return web-page
	 */
	function setupCampaign()
	{

		global $notify, $campaigns, $splashes, $counters;
		
		$id = isset($_GET['id']) ? (int)$_GET['id'] : '';
		
		// get campaign for editing
				$data = $campaigns->getOne($id);
			
			if ($id) {
				
				// Find out the specific time
				if ($data['expire_time'])
					$data['expire_time'] -= time();
				
				$expire_time = array();
				$expire_time['days'] = $data['expire_time'] ? floor($data['expire_time'] / UNIX_DAY) : 0;
				$expire_time['hours'] = $data['expire_time'] ? floor( ($data['expire_time'] - ($expire_time['days'] * UNIX_DAY) ) / UNIX_HOUR) : 0;
				$expire_time['minutes'] = $data['expire_time'] ? floor( ($data['expire_time'] - ($expire_time['days'] * UNIX_DAY) - ($expire_time['hours'] * UNIX_HOUR) ) / UNIX_MINUTE) : 0;
				$expire_time['seconds'] = $data['expire_time'] ? floor( ($data['expire_time'] - ($expire_time['days'] * UNIX_DAY) - ($expire_time['hours'] * UNIX_HOUR) - ($expire_time['minutes'] * UNIX_MINUTE) )) : 0;
				$data['expire_time'] = $expire_time;
	
				$expire_period = array();
				$expire_period['days'] = $data['expire_period'] ? floor($data['expire_period'] / UNIX_DAY) : 0;
				$expire_period['hours'] = $data['expire_period'] ? floor( ($data['expire_period'] - ($expire_period['days'] * UNIX_DAY) ) / UNIX_HOUR) : 0;
				$expire_period['minutes'] = $data['expire_period'] ? floor( ($data['expire_period'] - ($expire_period['days'] * UNIX_DAY) - ($expire_period['hours'] * UNIX_HOUR) ) / UNIX_MINUTE) : 0;
				$expire_period['seconds'] = $data['expire_period'] ? floor( ($data['expire_period'] - ($expire_period['days'] * UNIX_DAY) - ($expire_period['hours'] * UNIX_HOUR) - ($expire_period['minutes'] * UNIX_MINUTE) )) : 0;
				$data['expire_period'] = $expire_period;
				
			}
			else {
				$data = array_merge($data, MegaTicker_FormSaver::form_values());
				
				$expire_time['days'] = $data['expire_time_days'];
				$expire_time['hours'] = $data['expire_time_hours'];
				$expire_time['minutes'] = $data['expire_time_minutes'];
				$expire_time['seconds'] = $data['expire_time_seconds'];
				$data['expire_time'] = $expire_time;
	
				$expire_period = array();
				$expire_period['days'] = $data['expire_period_days'];
				$expire_period['hours'] = $data['expire_period_hours'];
				$expire_period['minutes'] = $data['expire_period_minutes'];
				$expire_period['seconds'] = $data['expire_period_seconds'];
				$data['expire_period'] = $expire_period;
			}
			
		
		// fetgetch main data
			extract($data);
		
		// get splashes list
			$splashes_list = $splashes->getList();
			
		// get counters list
			$counters_list = $counters->getList();

		// get timezones list
			$timezones_list = DateTimeZone::listIdentifiers();
		
		include_once(MEGATICKER_APPPATH.'/views/setup_campaign.php');
	}

	
	
	/*
	 * Creating campaign or saving extisted
	 * 
	 * @global $wpdb, $notify
	 * @return notify
	 */
	function saveCampaign()
	{
		global $campaigns, $notify;

		// check for wp nonce
			if ( empty($_POST) || !wp_verify_nonce($_POST['ticker'],'save_campaign') )
				$notify->returnError(__('Security error','megaticker'));
		
		$id = isset($_POST['id']) ? (int)$_POST['id'] : 0;

		if (!$id) {
			MegaTicker_FormSaver::hold_form_values(array(
				'name',
				'campaign_type',
				'redirect_url',
				'redirect_timeout',
				'event_on_finish',
				'splash_id',
				'counter_id',
				'timezone',
				
				'expire_time_days',
				'expire_time_hours',
				'expire_time_minutes',
				'expire_time_seconds',
				
				'expire_period_days',
				'expire_period_hours',
				'expire_period_minutes',
				'expire_period_seconds',
			));
		}
		
		// checking expire types
			$campaignTypes = array(
				'global',
				'individual',
			);
			if (MEGATICKER_EDITION == 'PRO')
				$campaignTypes[] = 'first_visit_only';
		 
			if (!in_array($_POST['campaign_type'],$campaignTypes))
				$notify->returnError(__('Unknown campaign type', 'megaticker'));
		
		// checking events on finish
			$eventsOnFinish = array(
				'redirect',
				'splash',
				'splash_and_redirect'
			);
			if (!in_array($_POST['event_on_finish'],$eventsOnFinish))
				$notify->returnError(__('Unknown event on finish', 'megaticker'));
		
		// checking required field
			$required = array(
				'name',
				'campaign_type',
				'redirect_url',
				'event_on_finish'
			);
			foreach($_POST as $k => $v)
			{
				if (in_array($k,$required) && $v == '')
					$notify->returnError('"'.$k.'"'.__('field is required', 'megaticker'));
				
				$_POST[$k] = sanitize_text_field($v);
			}
			
		// saving the data
			$formats = array();
			$data = array();
			
			$formats[] = '%s';
			$data['name'] = $_POST['name'];
			
			if ($_POST['campaign_type'] == 'global')
			{
				$days = isset($_POST['expire_time_days']) ? ($_POST['expire_time_days'] * 24 * 60 * 60) : 0;
				$hours = isset($_POST['expire_time_hours']) ? ($_POST['expire_time_hours'] * 60 * 60) : 0;
				$minutes = isset($_POST['expire_time_minutes']) ? ($_POST['expire_time_minutes'] * 60) : 0;
				$seconds = isset($_POST['expire_time_seconds']) ? ($_POST['expire_time_seconds']) : 0;
				
				$formats[] = '%d';
				$data['expire_time'] = time() + $days + $hours + $minutes + $seconds;
			}
			elseif ($_POST['campaign_type'] == 'individual')
			{
				$days = isset($_POST['expire_period_days']) ? ($_POST['expire_period_days'] * 24 * 60 * 60) : 0;
				$hours = isset($_POST['expire_period_hours']) ? ($_POST['expire_period_hours'] * 60 * 60) : 0;
				$minutes = isset($_POST['expire_period_minutes']) ? ($_POST['expire_period_minutes'] * 60) : 0;
				$seconds = isset($_POST['expire_period_seconds']) ? ($_POST['expire_period_seconds']) : 0;
				
				$formats[] = '%d';
				$data['expire_period'] = $days + $hours + $minutes + $seconds;
			}
			
			$formats[] = '%s';
			$data['campaign_type'] = $_POST['campaign_type'];
			
			$formats[] = '%s';
			$data['redirect_url'] = esc_url($_POST['redirect_url']);
			
			$formats[] = '%s';
			$data['event_on_finish'] = $_POST['event_on_finish'];
			
			$formats[] = '%d';
			$data['redirect_timeout'] = isset($_POST['redirect_timeout']) ? (int)$_POST['redirect_timeout'] : '';
			
			if (MEGATICKER_EDITION == 'PRO')
			{
				$formats[] = '%d';
				$data['splash_id'] = isset($_POST['splash_id']) ? (int)$_POST['splash_id'] : '';
			}
			
			$formats[] = '%d';
			$data['counter_id'] = isset($_POST['counter_id']) ? (int)$_POST['counter_id'] : '';
			
			$formats[] = '%s';
			$data['timezone'] = isset($_POST['timezone']) ? $_POST['timezone'] : '';
		
		
		// create
			if (!$id)
			{
				$result = $campaigns->insert($data, $formats);
				
				if ($result)
				{
					MegaTicker_FormSaver::clear_form_values();
					$notify->setComeback(admin_url('admin.php?page=megaticker/megaticker.php?setup_campaign',false).'&id='.$campaigns->insert_id);
				}
			}
			
		// or edit
			else
			{
				$result = $campaigns->update($data, array( 'id' => $id ));
			}
		
		// get final message to user
			if ($result)
				$notify->returnSuccess(__('Campaign Saved', 'megaticker'));
			else
				$notify->returnError(__('Error saving campaign: ', 'megaticker').$wpdb->print_error());
	}
	

	/*
	 * Copying campaign
	 * 
	 * @global $notify, $campaigns
	 * @return notify
	 */
	function copyCampaign()
	{
		global $notify,$campaigns;
		
		$id = isset($_GET['id']) ? (int)$_GET['id'] : '';
		$new_name = isset($_GET['new_name']) ? sanitize_text_field($_GET['new_name']) : '';
		
		$result = $campaigns->copy($id, $new_name);
		
		// return final message to user
			if ($result)
				$notify->returnSuccess(__('Campaign Copied', 'megaticker'));
			else
				$notify->returnError(__('Error copying campaign: ', 'megaticker').$wpdb->print_error());
	}


	/*
	 * Deleting campaign
	 * 
	 * @global $notify, $campaigns
	 * @return notify
	 */
	function deleteCampaign()
	{
		global $notify,$campaigns;
		
		// deleting
			$result = false;
			if (isset($_REQUEST['id']) && is_array($_REQUEST['id']) && count($_REQUEST['id']))
			{
				$ids = array();
				foreach($_REQUEST['id'] as $id)
				{
					if ((int)$id)
						$ids[] = (int)$id; 
				}
					
				$result = $campaigns->delete($ids);
			}
		
		// return final message to user
			if ($result)
				$notify->returnSuccess(__('Campaign Deleted', 'megaticker'));
			else
				$notify->returnError(__('Error deleting campaign: ', 'megaticker').$wpdb->print_error());
	}



