<?php if (!defined('WPINC')) die();

	
	/*
	 * Showing counters list
	 * 
	 * @global $notify
	 * @return web-page
	 */
	function counters()
	{
		global $notify, $counters;
		
		// including wp table
			include_once(MEGATICKER_APPPATH.'/views/counters-list.php');
			
			//Create an instance of our package class...
			$listTable = new MegaTicker_Counters_List_Table($counters);
			//Fetch, prepare, sort, and filter our data...
			$listTable->prepare_items();
		
		// go to view
			include_once(MEGATICKER_APPPATH.'/views/counters.php');
	}


	/*
	 * Showing counter setup form
	 * 
	 * @global $notify, $counters
	 * @return web-page
	 */
	function setupCounter()
	{
		global $notify, $counters;
		
		$id = isset($_GET['id']) ? (int)$_GET['id'] : '';
		
		// get main data
			$data = $counters->getOne($id);
			
			if (!$id)
			{
				$data = array_merge($data, MegaTicker_FormSaver::form_values());
			}
			
			extract($data);
			
		// background types
			$backgroundTypes = get_filenames(MEGATICKER_APPPATH.'/img/counters/');
		
		// extract params
			if ($id)
			{
				extract(json_decode($params,true));
				//print_r($params);
				//die();
			}
			
			
		// or setting defaults
			else
			{
				// defaults
					$show_countdown = 1;
					$show_labels = 1;
					$show_days = 1;
					$show_hours = 1;
					$show_minutes = 1;
					$show_seconds = 1;
					$size = 5;
					$background_color = '#000000';
					$digits_color = '#ffffff';
					$background_type = '';
			}

		// animation types list
		// @todo maybe someday will move it to database
			$animationTypes = array(
				'slide_down' => __('Slide down','megaticker'),
				'slide_up' => __('Slide up','megaticker'),
				'blind' => __('Blind','megaticker'),
				'jumping' => __('Basketball','megaticker'),
				'shuffling' => __('Shuffling','megaticker'),
				'blink' => __('Blink','megaticker'),
				'santa_barbara' => __('Santa Barbara','megaticker'),
				'waterdrops' => __('Water drops','megaticker'),
			);
		
		// themes list with dependencies each
		// @todo maybe someday will move it to database
			$themes = array(
				'' => array( 
					'title' => __('Rounded','megaticker'),
					'background_color' => true,
					'digits_color' => true,
					'animationTypes' => true,
					'size' => true
				),
				'rounded_with_outline' => array( 
					'title' => __('Rounded with outline','megaticker'),
					'background_color' => true,
					'digits_color' => true,
					'animationTypes' => true,
					'size' => true
				),
				'round' => array( 
					'title' => __('Round','megaticker'),
					'background_color' => true,
					'digits_color' => true,
					'animationTypes' => array('jumping'),
					'size' => '5'
				),
				'combined' => array( 
					'title' => __('Combined','megaticker'),
					'background_color' => '',
					'digits_color' => '',
					'animationTypes' => true,
					'size' => '5'
				),
				'asketic' => array( 
					'title' => __('Asketic','megaticker'),
					'background_color' => true,
					'digits_color' => true,
					'animationTypes' => true,
					'size' => true
				),
			);

		// go to view
			include_once(MEGATICKER_APPPATH.'/views/setup_counter.php');
	}

	
	/*
	 * Saving counter 
	 * 
	 * @global $notify, $wpdb
	 * @return notify
	 */
	function saveCounter()
	{
		global $notify, $counters;
		
		error_reporting(E_ALL);
		ini_set('display_errors',1);
	
		// checking wp nonce
			if ( empty($_POST) || !wp_verify_nonce($_POST['ticker'],'save_counter') )
				$notify->returnError(__('Security error','megaticker'));
		
		$id = isset($_POST['id']) ? (int)$_POST['id'] : 0;
		
		if (!$id) {
			MegaTicker_FormSaver::hold_form_values(array(
				'name',
				'show_countdown',
				'show_labels',
				'show_days',
				'show_hours',
				'show_minutes',
				'show_seconds',
				'size',
				'animation_type',
				'background_color',
				'theme',
				'digits_color',
				'background_type'
			));
		}
		
		// themes list with requirments each
		// @todo maybe someday will move it to database
			$animationTypes = array(
				'slide_down' => __('Slide down','megaticker'),
				'slide_up' => __('Slide up','megaticker'),
				'blind' => __('Blind','megaticker'),
				'jumping' => __('Basketball','megaticker'),
				'shuffling' => __('Shuffling','megaticker'),
				'blink' => __('Blink','megaticker'),
				'santa_barbara' => __('Santa Barbara','megaticker'),
				'waterdrops' => __('Water drops','megaticker'),
			);
			if (!in_array($_POST['animation_type'],array_keys($animationTypes)))
				$notify->returnError(__('Unknown animation type', 'megaticker'));
		
			if ($_POST['background_type'] && !in_array($_POST['background_type'],get_filenames(MEGATICKER_APPPATH.'/img/counters/')))
				$notify->returnError(__('Unknown background type', 'megaticker'));
		
		
		// checking required fields
			$required = array(
				'name',
				'animation_type'
			);
			foreach($_POST as $k => $v)
			{
				if (in_array($k,$required) && $v == '')
					$notify->returnError('"'.$k.'"'.__('field is required', 'megaticker'));
				
				$_POST[$k] = sanitize_text_field($v);
			}
		
		// saving the data
			$formats = array();
			$data = array();
			
			$formats[] = '%s';
			$data['name'] = $_POST['name'];
			
			// packing extra params
				$params = array();
				$params['show_countdown'] = isset($_POST['show_countdown']) ? (int)($_POST['show_countdown']) : '';
				$params['show_labels'] = isset($_POST['show_labels']) ? (int)($_POST['show_labels']) : '';
				$params['show_days'] = isset($_POST['show_days']) ? (int)($_POST['show_days']) : '';
				$params['show_hours'] = isset($_POST['show_hours']) ? (int)($_POST['show_hours']) : '';
				$params['show_minutes'] = isset($_POST['show_minutes']) ? (int)($_POST['show_minutes']) : '';
				$params['show_seconds'] = isset($_POST['show_seconds']) ? (int)($_POST['show_seconds']) : '';
				$params['size'] = isset($_POST['size']) ? (int)($_POST['size']) : '';
				$params['animation_type'] = isset($_POST['animation_type']) ? ($_POST['animation_type']) : '';
				$params['background_color'] = $_POST['background_color'];
				
				if (MEGATICKER_EDITION == 'PRO')
					$params['theme'] = $_POST['theme'];
					
				$params['digits_color'] = $_POST['digits_color'];
				
				if (MEGATICKER_EDITION == 'PRO')
					$params['background_type'] = isset($_POST['background_type']) ? ($_POST['background_type']) : '';

				$formats[] = '%s';
				$data['params'] = json_encode($params);
		
		// creating
			$result = false;
			if (!$id)
			{
				$result = $counters->insert($data, $formats);
				
				if ($result)
				{
					MegaTicker_FormSaver::clear_form_values();
					$notify->setComeback(admin_url('admin.php?page=megaticker/megaticker.php?setup_counter',false).'&id='.$counters->insert_id);
				}
			}
			
		// or saving existed
			else
			{
				$result = $counters->update($data, array( 'id' => $id ));
			}
		
		// return final message to user
			if ($result)
				$notify->returnSuccess(__('Counter Saved', 'megaticker'));
			else
				$notify->returnError(__('Error saving counter: ', 'megaticker').$wpdb->print_error());
	}
	
	
	/*
	 * Copying counter
	 * 
	 * @global $notify, $counters
	 * @return notify
	 */
	function copyCounter()
	{
		global $notify, $counters;
		
		// fetch data
			$id = isset($_GET['id']) ? (int)$_GET['id'] : '';
			$new_name = isset($_GET['new_name']) ? sanitize_text_field($_GET['new_name']) : '';
		
		// copying
			$result = $counters->copy($id, $new_name);
		
		// return final message to user
			if ($result)
				$notify->returnSuccess(__('Counter Copied', 'megaticker'));
			else
				$notify->returnError(__('Error copying counter: ', 'megaticker').$wpdb->print_error());
	}
	

	/*
	 * Deleting counter
	 * 
	 * @global $notify, $counters
	 * @return notify
	 */
	function deleteCounter()
	{
		global $notify, $counters;
		
		// deleting
			$result = false;
			if (isset($_REQUEST['id']) && is_array($_REQUEST['id']) && count($_REQUEST['id']))
			{
				$ids = array();
				foreach($_REQUEST['id'] as $id)
				{
					if ((int)$id)
						$ids[] = (int)$id; 
				}
					
				$result = $counters->delete($ids);
			}
		
		// return final message to user
			if ($result)
				$notify->returnSuccess(__('Counter Deleted', 'megaticker'));
			else
				$notify->returnError(__('Error deleting counter: ', 'megaticker').$wpdb->print_error());
	}
	
