<?php if (!defined('WPINC')) die();

	/*
	 * Parse post, search ticker shortcode, check if redirect is needed, redirect
	 * 
	 * @global $post, $campaigns
	 * @uses Ticker_model
	 * @return wp_redirect
	 */
	function checkMegaTickerRedirects()
	{
		if (is_single() or is_singular())
		{
			
			global $post;
			global $campaigns;
		
			$shortcode_parts = array();
			preg_match("/\[MegaTickerShortcode(.+)\]/", $post->post_content, $shortcode_parts); 
			
			// if ticker shortcode founded
				if (count($shortcode_parts) && isset($shortcode_parts[0]) && isset($shortcode_parts[1]))
				{
					$id = str2int($shortcode_parts[1]);
					
					if ($id)
					{

						if (!isset($_COOKIE['megaticker']) && isset($_SESSION['megaticker'])) {
							$_COOKIE['megaticker'] = $_SESSION['megaticker']['user']['cookie'];
							setcookie('megaticker', $_SESSION['megaticker']['user']['cookie'], (time() + (3 * 365 * 24 * 60 * 60)), '/', $_SERVER['HTTP_HOST']);
						}

						if (!isset($_SESSION['megaticker'])) {

							if (isset($_COOKIE['megaticker']))
								$_SESSION['megaticker'] = MegaTicker_model::getSession($_COOKIE['megaticker']);
							else {							
								$newSession = MegaTicker_model::startSession();
								setcookie('megaticker', $newSession['cookie'], (time() + (3 * 365 * 24 * 60 * 60)), '/', $_SERVER['HTTP_HOST']);
								$_SESSION['megaticker'] = array(
									'user' => $newSession,
									'visits' => array()
								);
							}
							
						} 
						
						$firstVisits = $_SESSION['megaticker']['visits'];

						$data = MegaTicker_model::getTicker($id);	

						// first visit only
							if ($data['campaign_type'] == 'first_visit_only')
							{
								if (count($firstVisits) && isset($firstVisits[$data['id'].'_'.md5(MegaTicker_FormSaver::current_url())])) {
									wp_redirect($data['redirect_url']);
									die();
								}
							}
							
						// global
							elseif ($data['campaign_type'] == 'global')
							{
								// expired then redirect
								if( ($data['expire_time'] + $data['redirect_timeout']) <= time())
								{
									wp_redirect($data['redirect_url']);
									die();
								}
							}
							
						// individual and first_visit_only
						// for this cases time for expire will be evaluated dynamically
							elseif (
									($data['campaign_type'] == 'individual' or $data['campaign_type'] == 'first_visit_only')
									&& isset($firstVisits[$data['id'].'_'.md5(MegaTicker_FormSaver::current_url())])
								)
							{
								// expired then redirect
								if( ($firstVisits[$data['id'].'_'.md5(MegaTicker_FormSaver::current_url())]['created'] + $data['expire_period'] + $data['redirect_timeout']) <= time())
								{
									wp_redirect($data['redirect_url']);
									die();
								}
							}	
						
			
						// storing new visit
							if ($data['campaign_type'] == 'individual' or $data['campaign_type'] == 'first_visit_only') {
								if (!isset($firstVisits[$data['id'].'_'.md5(MegaTicker_FormSaver::current_url())])) {
									$new_entry = MegaTicker_model::addSessionData($data['id']);
									
									$_SESSION['megaticker']['visits'][$data['id'].'_'.md5(MegaTicker_FormSaver::current_url())] = $new_entry;
								}
							} else {
								if (!isset($firstVisits[$data['id']])) {
									$new_entry = MegaTicker_model::addSessionData($data['id']);
									$_SESSION['megaticker']['visits'][$data['id']] = $new_entry;
								}
							}
						
						// control cache
							$ticker['time_to_redirect'] = 0;
							// global
								if ($data['campaign_type'] == 'global')
								{
									$ticker['time_to_redirect'] = $data['expire_time'] - time();
								}
								
							// individual and first_visit_only
							// for this cases time for expire will be evaluated dynamically
								elseif (
										($data['campaign_type'] == 'individual' or $data['campaign_type'] == 'first_visit_only')
										&& isset($firstVisits[$data['id'].'_'.md5(MegaTicker_FormSaver::current_url())])
									)
								{
									$ticker['time_to_redirect'] = ($firstVisits[$data['id'].'_'.md5(MegaTicker_FormSaver::current_url())]['created'] + $data['expire_period']) - time();
								}
						
							header("Cache-Control: no-store, no-cache, must-revalidate");
							header("Expires: " . date("r", 0));
						
					}
				}
		}
	}

	
	/*
	 * Show countdown ticker block
	 *
	 * @global $campaigns
	 * @uses Ticker_model
	 * @return html string
	 */
	function showMegaTicker($attr)
	{
		if (is_single() or is_singular())
		{
			//error_reporting(E_ALL);
			//ini_set('display_errors',1);
			
			ob_start();
	
			$id = isset($attr['id']) ? $attr['id'] : '';
			
			if ($id)
			{
				
				global $campaigns;
				
				// get ticker
					$data = MegaTicker_model::getTicker($id);
				
				if ($data && isset($data['id']) && $data['id'])
				{
					
					$firstVisits = $_SESSION['megaticker']['visits'];
		
					if (isset($data['counter_params']))
					// unpack counter settings
						$counterSettings = json_decode($data['counter_params'],true);
					else
						$counterSettings = array();
					
				
					$ticker['id'] = $data['id'];
					$ticker['campaign_type'] = $data['campaign_type'];
					$ticker['redirect_url'] = $data['redirect_url'];
					$ticker['event_on_finish'] = $data['event_on_finish'];
					$ticker['redirect_timeout'] = $data['redirect_timeout'];
					$ticker['splash_url'] = $data['splash_url'];
					$ticker['splash_type'] = $data['splash_type'];
					 
					//splash css
						$ticker['splash_css'] = json_decode($data['splash_css'],true);
						$ticker['splash_css_string'] = array();
						if (count($ticker['splash_css']))
						{
							foreach($ticker['splash_css'] as $key => $value)
							{
								$ticker['splash_css_string'][] = $key.': '.$value;
							}
						}
						$ticker['splash_css_string'] = implode(';',$ticker['splash_css_string']);
		
					$ticker = array_merge($ticker,$counterSettings);	
	
					if ($ticker['id'])
					{
	
						// global
							if ($data['campaign_type'] == 'global')
							{
								$ticker['time_to_redirect'] = $data['expire_time'] - time();
							}
							
						// individual
						// for this cases time for expire will be evaluated dynamically
							elseif (
									($data['campaign_type'] == 'individual' or $data['campaign_type'] == 'first_visit_only')
									&& isset($firstVisits[$data['id'].'_'.md5(MegaTicker_FormSaver::current_url())])
								)
							{
								$ticker['time_to_redirect'] = ($firstVisits[$data['id'].'_'.md5(MegaTicker_FormSaver::current_url())]['created'] + $data['expire_period']) - time();
							}	
						
						
						$ticker['until'] = $ticker['time_to_redirect'];
						
		
						include(MEGATICKER_APPPATH.'/views/megaticker.php');
					}
				}
			}
			
			$html = ob_get_contents();
			ob_clean();
			
			return $html;
		}
	}
