<?php if (!defined('WPINC')) die();


	/*
	 * Showing splashes list
	 * 
	 * @global $notify
	 * @return web-page
	 */
	function splashes()
	{
		global $notify, $splashes;
		
		// including wp table
			include_once(MEGATICKER_APPPATH.'/views/splashes-list.php');
			
			//Create an instance of our package class...
			$listTable = new MegaTicker_Splashes_List_Table($splashes);
			//Fetch, prepare, sort, and filter our data...
			$listTable->prepare_items();
		
		// go to view
			include_once(MEGATICKER_APPPATH.'/views/splashes.php');
	}



	/*
	 * Showing counter setup form
	 * 
	 * @global $notify, $counters
	 * @return web-page
	 */
	function setupSplash()
	{
		global $notify,$splashes;

		$id = isset($_GET['id']) ? (int)$_GET['id'] : '';
		
		// get main data
			$data = $splashes->getOne($id);
		
			if (!$id)
			{
				$data = array_merge($data, MegaTicker_FormSaver::form_values());
			}
		 
		// extracting extra css params
			@extract(json_decode($data['css'], true));
			unset($data['css']);
			
			// extracting other params
				extract($data);

		// go to view
			include_once(MEGATICKER_APPPATH.'/views/setup_splash.php');
	}

	
	/*
	 * Saving splash 
	 * 
	 * @global $notify, $wpdb
	 * @return notify
	 */
	function saveSplash()
	{
		global $notify, $splashes;
		
		// checking wp nonce
			if ( empty($_POST) || !wp_verify_nonce($_POST['ticker'],'save_splash') )
				$notify->returnError(__('Security error','megaticker'));
		
		$id = isset($_POST['id']) ? (int)$_POST['id'] : 0;
		
		if (!$id) {
			MegaTicker_FormSaver::hold_form_values(array(
				'name',
				'type',
				'url',
				'width',
				'height'
			));
		}
				
		// checking required fields
			$required = array(
				'name',
				'type',
				'url',
			);
			foreach($_POST as $k => $v)
			{
				if (in_array($k,$required) && $v == '')
					$notify->returnError('"'.$k.'"'.__('field is required', 'megaticker'));
				
				$_POST[$k] = sanitize_text_field($v);
			}
		
		// splash types list
		// @todo maybe someday will move it to database
			$types = array(
				'image',
				'youtube',
				'webpage'
			);
			if (!in_array($_POST['type'],$types))
				$notify->returnError(__('Unknown splash type', 'megaticker'));
		
		
		// saving the data
			$formats = array();
			$data = array();
			
			$formats[] = '%s';
			$data['name'] = $_POST['name'];
			
			$formats[] = '%s';
			$data['type'] = $_POST['type'];
			
			// trying to find out the youtube video identifier
				$formats[] = '%s';
				$data['url'] = '';
				if ($data['type'] == 'youtube')
				{					
					$data['url'] = megaticker_get_youtube_id($_POST['url']);
				}
				
				if (!$data['url'])
					$data['url'] = esc_url($_POST['url']);
			
			
			// packing css
				$css = array(
					'width' => str2int($_POST['width']),
					'height' => str2int($_POST['height']),
				);
				$formats[] = '%s';
				$data['css'] = json_encode($css);
		
		// creating
			if (!$id)
			{
				$result = $splashes->insert($data, $formats);
				
				if ($result)
				{
					MegaTicker_FormSaver::clear_form_values();
					$notify->setComeback(admin_url('admin.php?page=megaticker/megaticker.php?setup_splash',false).'&id='.$splashes->insert_id);
				}
			}
		
		// or saving existed
			else
			{
				$result = $splashes->update($data, array( 'id' => $id ));
			}
		
		// return final message to user
			if ($result)
				$notify->returnSuccess(__('Splash saved', 'megaticker'));
			else
				$notify->returnError(__('Error saving splash: ', 'megaticker').$wpdb->print_error());
	}
	

	/*
	 * Deleting splash
	 * 
	 * @global $notify, $splashes
	 * @return notify
	 */
	function deleteSplash()
	{
		global $notify, $splashes;
		
		// deleting
			$result = false;
			if (isset($_REQUEST['id']) && is_array($_REQUEST['id']) && count($_REQUEST['id']))
			{
				$ids = array();
				foreach($_REQUEST['id'] as $id)
				{
					if ((int)$id)
						$ids[] = (int)$id; 
				}
					
				$result = $splashes->delete($ids);
			}
		
		// return final message to user
			if ($result)
				$notify->returnSuccess(__('Splash Deleted', 'megaticker'));
			else
				$notify->returnError(__('Error deleting splash: ', 'megaticker').$wpdb->print_error());
	}
	
	