<?php if (!defined('WPINC')) die();

/* ticker install */

function installMegaTicker() {

	global $wpdb, $wp_version;
	
	$sql = '
		CREATE TABLE IF NOT EXISTS `'.$wpdb->prefix.'megaticker_campaigns` (
			`id` int(11) NOT NULL auto_increment,
			`campaign_type` varchar(50) NOT NULL,
			`name` varchar(255) NOT NULL,
			`expire_time` int(11) NOT NULL,
			`expire_period` int(11) NOT NULL,
			`redirect_url` varchar(255) NOT NULL,
			`event_on_finish` varchar(20) NOT NULL,
			`first_visit_only` int(1) NOT NULL,
			`splash_id` int(11) NOT NULL,
			`counter_id` int(11) NOT NULL,
			`redirect_timeout` int(11) NOT NULL,
			`timezone` varchar(50) NOT NULL,
			PRIMARY KEY  (`id`),
			KEY `expire_time` (`expire_time`),
			KEY `splash_id` (`splash_id`),
			KEY `counter_id` (`counter_id`)
		) ENGINE=MyISAM  DEFAULT CHARSET=utf8 AUTO_INCREMENT=0 ;
	';
	$wpdb->query($sql);
	
	$sql = '
		CREATE TABLE IF NOT EXISTS `'.$wpdb->prefix.'megaticker_counters` (
			`id` int(11) NOT NULL auto_increment,
			`name` varchar(255) NOT NULL,
			`params` longtext NOT NULL,
			PRIMARY KEY  (`id`)
		) ENGINE=MyISAM  DEFAULT CHARSET=utf8 AUTO_INCREMENT=0 ;
	';
	$wpdb->query($sql);
	
	$sql = '
		CREATE TABLE IF NOT EXISTS `'.$wpdb->prefix.'megaticker_splashes` (
		  `id` int(13) NOT NULL auto_increment,
		  `name` varchar(255) character set utf8 collate utf8_unicode_ci NOT NULL,
		  `type` varchar(20) character set utf8 collate utf8_unicode_ci NOT NULL,
		  `url` varchar(255) NOT NULL,
		  `css` longtext NOT NULL,
		  PRIMARY KEY  (`id`)
		) ENGINE=MyISAM  DEFAULT CHARSET=utf8 AUTO_INCREMENT=0 ;
	';
	$wpdb->query($sql);
	
	
	$sql = '
		CREATE TABLE `'.$wpdb->prefix.'megaticker_sessions` (
			`id` int(11) NOT NULL auto_increment,
			`cookie` varchar(255) NOT NULL,
			PRIMARY KEY  (`id`)
		) ENGINE = MYISAM CHARACTER SET utf8 COLLATE utf8_general_ci ;
	';
	$wpdb->query($sql);
	
	
	$sql = '
		CREATE TABLE `'.$wpdb->prefix.'megaticker_sessions_data` (
			`id` INT NOT NULL auto_increment,
			`session_id` INT NOT NULL ,
			`campaign_id` INT NOT NULL ,
			`url` VARCHAR( 255 ) NOT NULL ,
			`created` INT NOT NULL ,
			PRIMARY KEY ( `id` ) ,
			INDEX ( `session_id` , `campaign_id` )
		) ENGINE = MYISAM CHARACTER SET utf8 COLLATE utf8_general_ci ;
	';
	$wpdb->query($sql);

	
	add_option('megaticker__version', MEGATICKER_VERSION);
	add_option('megaticker__edition', MEGATICKER_EDITION);
	
	if (!get_option('megaticker__activation_code'))
	{
		add_option('megaticker__activation_code', '');
		add_option('megaticker__registered_to_email', '');
		add_option('megaticker__registered_on_domain', '');
	}
	
	try {
	 	if( !class_exists( 'WP_Http' ) )
		    include_once( ABSPATH . WPINC. '/class-http.php' );
		 
		$http = new WP_Http();
	    $http->request(MTSS_RECIVER, array( 'method' => 'POST', 'body' => array(
			'operation' => 'activation',
			'domain' => $_SERVER['HTTP_HOST'],
			'ip' => $_SERVER['SERVER_ADDR'],
			'php_version' => PHP_VERSION,
			'wp_version' => $wp_version,
			'wp_language' => WPLANG,
			'plugin_version' => MEGATICKER_VERSION,
			'plugin_edition' => MEGATICKER_EDITION,
			'plugin_activation_code' => get_option('megaticker__activation_code'),
		)));
		
	} catch(Exception $e) {}
}



function uninstallMegaTicker() {
	
	global $wp_version;
	
	delete_option('megaticker__version');
	delete_option('megaticker__edition');
	
	try {
		if( !class_exists( 'WP_Http' ) )
		    include_once( ABSPATH . WPINC. '/class-http.php' );
 
		$http = new WP_Http();
	    $http->request(MTSS_RECIVER, array( 'method' => 'POST', 'body' => array(
			'operation' => 'deactivation',
			'domain' => $_SERVER['HTTP_HOST'],
			'ip' => $_SERVER['SERVER_ADDR'],
			'php_version' => PHP_VERSION,
			'wp_version' => $wp_version,
			'wp_language' => WPLANG,
			'plugin_version' => MEGATICKER_VERSION,
			'plugin_edition' => MEGATICKER_EDITION,
			'plugin_activation_code' => get_option('megaticker__activation_code'),
		)));
		
	} catch(Exception $e) {}
}
