if (typeof(MegaTicker) == 'undefined')
{
	var MegaTicker = {};
}

if (typeof(MegaTicker.themes) == 'undefined')
	MegaTicker.themes = [];

(function($) {
	
	var slider;
 
	jQuery(window).ready(function(){
		if ($( "#counter_size" ).length)
		{
			var select = $( "#counter_size" );
			slider = $( "<div id='counter_size_slider'></div>" ).insertAfter( select ).slider({
				min: 1,
				max: 10,
				range: "min",
				value: select[ 0 ].selectedIndex + 1,
				slide: function( event, ui ) {
					select[ 0 ].selectedIndex = ui.value - 1;
				},
				change: function(event, ui) {
					preview_counter();
				}
			});

			$( "#counter_size" ).change(function() {
				slider.slider( "value", this.selectedIndex + 1 );
			}).trigger("change").hide();
		}
	});
	
 
	

	function themeSet(settings)
	{
	
		if(settings.background_color === true)
		{
			$(".background_color_control").removeClass('hidden').show(0);
			$(".background_color_control_placeholder").addClass('hidden').hide(0);
		}
		else
		{
			$(".background_color_control").addClass('hidden').hide(0).val(settings.background_color);
			$(".background_color_control_placeholder").removeClass('hidden').show(0);
			$("input",".background_color_control").val(settings.background_color);
		}
		
		if(settings.digits_color === true)
		{
			$(".digits_color_control").removeClass('hidden').show(0);
			$(".digits_color_control_placeholder").addClass('hidden').hide(0);
		}
		else
		{
			$(".digits_color_control").addClass('hidden').hide(0).val(settings.digits_color);
			$(".digits_color_control_placeholder").removeClass('hidden').show(0);
			$("input",".digits_color_control").val(settings.digits_color);
		}
		
		if(settings.animationTypes === true)
		{
			$(".animation_type_control").removeClass('hidden').show(0);
			$(".animation_type_control_placeholder").addClass('hidden').hide(0);
		}
		else
		{
			$(".animation_type_control").addClass('hidden').hide(0);
			$(".animation_type_control_placeholder").removeClass('hidden').show(0);
			$("select[name='animation_type']",".counter_preview_form").val(settings.animationTypes);
		}

		if(settings.size === true)
		{
			$(".size_control").removeClass('hidden').show(0);
			$(".size_control_placeholder").addClass('hidden').hide(0);
		}
		else
		{
			$(".size_control").addClass('hidden').hide(0);
			$(".size_control_placeholder").removeClass('hidden').show(0);
			
			slider.slider( "option", "value", settings.size);
			$("select[name='size']",".counter_preview_form").val(settings.size);
		}
		

	}

	
	function preview_counter()
	{
		var styles = '';
				
		var show_countdown = $("input[name='show_countdown']",".counter_preview_form").is(":checked");
		var show_labels = $("input[name='show_labels']",".counter_preview_form").is(":checked");
		var show_days = $("input[name='show_days']",".counter_preview_form").is(":checked");
		var show_hours = $("input[name='show_hours']",".counter_preview_form").is(":checked");
		var show_minutes = $("input[name='show_minutes']",".counter_preview_form").is(":checked");
		var show_seconds = $("input[name='show_seconds']",".counter_preview_form").is(":checked");
		var animation_type = $("select[name='animation_type']",".counter_preview_form").val();
		var background_type = $("select[name='background_type']",".counter_preview_form").val();
		var digits_color = $("#digits_color",".counter_preview_form").val() ? $("#digits_color",".counter_preview_form").val() : '#fff';
		var background_color = $("#background_color",".counter_preview_form").val() ? $("#background_color",".counter_preview_form").val() : '#444';
		var theme = $("input[name='theme']:checked",".counter_preview_form").val();
		var size = slider.slider( "option", "value" ) ? slider.slider( "option", "value" ) : $("select[name='size']",".counter_preview_form").val() ;
	
		if (background_type) {
			$repeat = background_type;
			$repeat = $repeat.split("__");
			$repeat = $repeat[1];
			
			styles += "#ticker0 .digit {"
				+"background-image: url("+plugins_url('img/counters/'+background_type)+");"
				+"background-repeat: "+$repeat+";"
			+"}";
		}
				
		styles += ".countdown .countDiv:before, .countdown .countDiv:after { background-color: "+background_color+"; }";
		
		styles += ".countdown .digit, .countdown .digit.static {"
			+"background-color: "+background_color+";"
			+"color: "+digits_color+";"
		+"}";

		/*styles += ".countdown .digit {"
			+"background-color: "+background_color+";"
		+"}";*/
		
		styles += ".countdown {"
			+"font-size: "+(size ? (size*10)/2 : '40')+"pt;"
			+"color: "+background_color+";"
		+"}";

		if (show_countdown)
			styles += ".preview .content {"
				+"display: block;"
			+"}";
		else
			styles += ".preview .content {"
				+"display: none;"
			+"}";
			
			
		if (show_days)
			styles += ".preview .content .Days {"
				+"display: block;"
			+"}";
		else
			styles += ".preview .content .Days {"
				+"display: none;"
			+"}";
		
		
		if (show_hours)
			styles += ".preview .content .Hours {"
				+"display: block;"
			+"}";
		else
			styles += ".preview .content .Hours {"
				+"display: none;"
			+"}";
			
			
		if (show_minutes)
			styles += ".preview .content .Minutes {"
				+"display: block;"
			+"}";
		else
			styles += ".preview .content .Minutes {"
				+"display: none;"
			+"}";
			
			
		if (show_seconds)
			styles += ".preview .content .Seconds {"
				+"display: block;"
			+"}";
		else
			styles += ".preview .content .Seconds {"
				+"display: none;"
			+"}";
		
		
		if (show_labels)
			styles += ".preview .content .label {"
				+"display: block;"
			+"}";
		else
			styles += ".preview .content .label {"
				+"display: none;"
			+"}";
			
		
		if (!$(".preview style").size())
			$(".preview").append('<style type="text/css" id="previews_style"></style>');
				

		$("#previews_style").text(styles);
		
		
		
		var html = '<div id="ticker0"></div>';
		$("#ticker0").remove();
		$(".preview .content").html(html);
		
		$('#ticker0')
			.stopCountdown()
			.countdown({
				timestamp: Math.floor(Date.parse(new Date()) / 1000) + 8700,
				animation: animation_type,
				regional: ( typeof($.counterRegional) != 'undefined' ? $.counterRegional : null )
			})
			.addClass(theme)
			.addClass(animation_type);
			
		
	}
	
	
	
	
	$(document).ready(function()
	{

		// tooltips
			$(".MegaTickerPROOption", ".unregistered").click(function(e){
				e.preventDefault();
				return false;
			});
			$(".MegaTickerPROOption option", ".unregistered").click(function(e){
				e.preventDefault();
				return false;
			});
			
			
			$(".MegaTickerPROOption", ".unregistered").bt({
				contentSelector: $(".btTooltipProContainer"),
				trigger: ['click','click'],
				closeWhenOthersOpen: true,
				padding: '10px', // padding for content (get more fine grained with cssStyles)
				spikeGirth: 5, // width of spike
				spikeLength: 10, // length of spike
				fill: "#3FC4EF",
				strokeWidth: 1, // width of stroke around box, **set to 0 for no stroke**
				strokeStyle: "#3FC4E0", // color/alpha of stroke
				cornerRadius: 2, // radius of corners (px), set to 0 for square corners
				shadow: true,
				shadowColor:      "#333",                // shadow color/alpha
				width: 400,
				cssStyles: {
					color: '#fff',
					'text-shadow': '-1px -1px 0px #666'
				}
			});
	
		// функция проверки confirm
		$(".confirm").click(function(event)
		{
			var title = $(this).attr("title");
			if (!confirm(title))
			{
				return false;
			}

			return true;
		});
		// функция проверки confirm
		
		
		// функция проверки confirm
		$(".copy_activator").live("click",function(event)
		{
			var name = prompt(MegaTickerLANG['Enter new name']);
			if (name)
			{
				$(this).attr("href",$(this).attr("href")+"&new_name="+name);
				return true;
			}
			else
			{
				return true;
			}
			
			return false;
		});
		
	// datepicker
		$(".datepicker").datepicker();

	// combobox	
		$(".combobox").combobox();

	// tabs
		$(".tabs").tabs();
		
	// tabs
		$(".accordion").accordion({
				animated: false,
				icons:false 
		});
		 
		
	// validation
	if ($(".validateThisForm").size())
		$(".validateThisForm").validate();
		
	// file uploading
	if ($('.splash_upload').size())
	{
		$('.splash_upload').click(function() {
			tb_show('', 'media-upload.php?type=image&amp;TB_iframe=true');
			return false;
		});
		 
		
		window.send_to_editor = function(html) {
		
			imgurl = $('img',html).attr('src');
			
			if (!imgurl)
				imgurl = $(html).attr('src');
				
			$('.splash_image_url').val(imgurl).trigger("change");
			tb_remove();
		}
	}
		
		$('.splash_image_url').change(function()
		{
			var url = $(".splash_image_url_favicon").attr("data-src");
		
			var l = getLocation($(this).val());
			var domain = l.hostname;
		
			var src = url+domain+"&rand="+Math.random();
		
			$(".splash_image_url_favicon").attr("src",src);
		});
		
		
		
		
		// colorpicker
		
			// digits color
				if ($('#digits_color_preview').size())
				{
					$('#digits_color_preview').farbtastic(function(color){
						$('#digits_color').val(color).trigger("change");
					});
				}
				
			// background color	
				
				if ($('#background_color_preview').size())
				{
					$('#background_color_preview').farbtastic(function(color){
						$('#background_color').val(color).trigger("change");
					});
				}
			
			
		// previews

			$("input",".splash_preview_form").change(function(){
				
				var name = $("input[name='name']",".splash_preview_form").val();
				var type = $("input[name='type']:checked",".splash_preview_form").val();
				var url = $("input[name='url']",".splash_preview_form").val();
				var width = $("input[name='width']",".splash_preview_form").val();
				var height = $("input[name='height']",".splash_preview_form").val();
				
				var html = '';
				switch(type)
				{
					case 'image':
						html = '<img src="'+url+'" alt="'+name+'" style="max-width: '+width+'px;max-height: '+height+'px;"/>';
					break;
					
					case 'webpage':
						html = '<iframe src="'+url+'" style="width: '+width+'px;height: '+height+'px;"></iframe>';
					break;
					
					case 'youtube':
						var l = getLocation(url);
	
						var domain = l.hostname;
						
						iframe_height = height - 60;
						iframe_width = width - 35;
						
						if (domain == 'youtube.com' || domain == 'www.youtube.com')
						{
							var video = l.search.split("?").join("").toString();
							var video_attrs = [];
							parse_str(video, video_attrs);
						
							if (typeof(video_attrs.v) != 'undefined')
								html = '<iframe src="http://www.youtube.com/embed/'+video_attrs.v+'" style="width: '+iframe_width+'px;height: '+iframe_height+'px;"></iframe>';
						}
						else if (domain == 'youtu.be') {
							l.pathname = l.pathname.split("/").join("").toString();
							if (l.pathname)
								html = '<iframe src="http://www.youtube.com/embed/'+l.pathname+'" style="width: '+iframe_width+'px;height: '+iframe_height+'px;"></iframe>';
						}
						
						if (!html)
							html = '<iframe src="'+url+'" style="width: '+iframe_width+'px;height: '+iframe_height+'px;"></iframe>';
							
					break;
				}
				
				
				
				$("#basic-modal-content")
					.fadeOut(200,function(){
						
						$(this).html(html).fadeIn(200);
						
						$("#simplemodal-container").css({
							'width': width+'px',
							'height': height+'px'
						});
						
					});
					
				
			});
			$("input:first",".splash_preview_form").trigger("change");
			
			
		// preview counter
		
			$("input,select",".counter_preview_form").change(function(){
				preview_counter();
			});
			$("input:first",".counter_preview_form").trigger("change");

		
		// timepicker
			$('.timepicker').jtimepicker({
				clockIcon: plugins_url('img/icon_clock_2.gif'),
				orientation: 'horizontal',
				htmlControl: 'input',
				// set days
                dayCombo: 'expire_time_days',
				dayLength: 30,
                dayInterval: 1,
                dayDefaultValue: $("input[name='expire_time_days']").val(),
                daySlider: 'daySlider',
                dayLabel: MegaTickerLANG['days'],
                // set hours
                hourCombo: 'expire_time_hours',
                hourMode: 24,
                hourInterval: 1,
                hourDefaultValue: $("input[name='expire_time_hours']").val(),
                hourSlider: 'hourSlider',
                hourLabel: MegaTickerLANG['hours'],
                // set minutes
                minCombo: 'expire_time_minutes',
                minLength: 60,
                minInterval: 1,
                minDefaultValue: $("input[name='expire_time_minutes']").val(),
                minSlider: 'minSlider',
                minLabel: MegaTickerLANG['minutes'],
                // set seconds
                secView: true,
                secCombo: 'expire_time_seconds',
                secLength: 60,
                secInterval: 1,
                secDefaultValue: $("input[name='expire_time_seconds']").val(),
                secSlider: 'secSlider',
                secLabel: MegaTickerLANG['seconds']
			});
			
			
			$('.timepicker_period').jtimepicker({
				clockIcon: plugins_url('img/icon_clock_2.gif'),
				orientation: 'horizontal',
				htmlControl: 'input',
				// set days
                dayCombo: 'expire_period_days',
				dayLength: 30,
                dayInterval: 1,
                dayDefaultValue: $("input[name='expire_period_days']").val(),
                daySlider: 'daySlider',
                dayLabel: MegaTickerLANG['days'],
                // set hours
                hourCombo: 'expire_period_hours',
                hourMode: 24,
                hourInterval: 1,
                hourDefaultValue: $("input[name='expire_period_hours']").val(),
                hourSlider: 'hourSlider',
                hourLabel: MegaTickerLANG['hours'],
                // set minutes
                minCombo: 'expire_period_minutes',
                minLength: 60,
                minInterval: 1,
                minDefaultValue: $("input[name='expire_period_minutes']").val(),
                minSlider: 'minSlider',
                minLabel: MegaTickerLANG['minutes'],
                // set seconds
                secView: true,
                secCombo: 'expire_period_seconds',
                secLength: 60,
                secInterval: 1,
                secDefaultValue: $("input[name='expire_period_seconds']").val(),
                secSlider: 'secSlider',
                secLabel: MegaTickerLANG['seconds']
			});
			
			
			
		// first_visit_only
			/*$("input[name='first_visit_only']").change(function()
			{
				if ($(this).is(":checked"))
				{
					$("#remember_user_no").removeAttr("checked").attr("readonly","readonly");
					$("#remember_user_yes").attr("checked","checked").attr("readonly","readonly");
	
				}
				else
				{
					$("#remember_user_yes").removeAttr("checked").removeAttr("readonly");
					$("#remember_user_no").attr("checked","checked").removeAttr("readonly");
					
				}
			}).trigger("change");*/
		
		
		$("input[name='event_on_finish']").change(function()
		{
			$("select",".visual_container").removeAttr("disabled");
			
			if ($(this).is(":checked") && $(this).val() == 'splash_and_redirect')
			{
				$("input[name='redirect_timeout']").removeAttr("disabled");
				
			}
			else if ($(this).is(":checked") && $(this).val() == 'splash')
			{
				$("input[name='redirect_timeout']").attr("disabled","disabled");
				
				
				if ($("input[name='campaign_type']:checked").val() == 'first_visit_only')
					$("select[name='counter_id']",".visual_container").attr("disabled", "disabled");
			}
			else
			{
				$("input[name='redirect_timeout']").attr("disabled","disabled");
				
				
				if ($("input[name='campaign_type']:checked").val() == 'first_visit_only')
					$("select",".visual_container").attr("disabled", "disabled");
			}
		}).trigger("change");
		
		
		/*$("input[name='expire_date']").focus(function()
		{
			$("#specific_date").trigger('click');
		});
		
		
		$(".timepicker").click(function()
		{
			$("#specific_time").attr('checked','checked');
		});*/
		
		$("input[name='campaign_type']").focus(function()
		{
			$("select",".visual_container").removeAttr("disabled");
			
			if ($(this).val() == 'global')
			{
				$(".timepicker_container").slideDown(500);
				$(".timepicker_period_container").slideUp(500);
				
				if ($("#event_on_finish_splash_and_redirect").parent().hasClass("hidden"))
				{
					$("#event_on_finish_splash_and_redirect").removeAttr("disabled");
					$("#event_on_finish_splash_and_redirect").parent().removeClass("hidden");
				}
			}
			else if ($(this).val() == 'individual')
			{
				$(".timepicker_container").slideUp(500);
				$(".timepicker_period_container").slideDown(500);
				
				if ($("#event_on_finish_splash_and_redirect").parent().hasClass("hidden"))
				{
					$("#event_on_finish_splash_and_redirect").removeAttr("disabled");
					$("#event_on_finish_splash_and_redirect").parent().removeClass("hidden");
				}
			}
			else
			{
				$(".timepicker_container").slideUp(500);
				$(".timepicker_period_container").slideUp(500);
				
				if ($("input[name='event_on_finish']:checked").val() == 'redirect')
					$("select",".visual_container").attr("disabled", "disabled");
				else if ($("input[name='event_on_finish']:checked").val() == 'splash')
					$("select[name='counter_id']",".visual_container").attr("disabled", "disabled");
				
				if (!$("#event_on_finish_splash_and_redirect").parent().hasClass("hidden"))
				{
					$("#event_on_finish_splash_and_redirect").attr("disabled", "disabled");
					$("#event_on_finish_splash_and_redirect").parent().addClass("hidden");
				}
			}
		});
		if ($("input[name='campaign_type']:checked").size())
			$("input[name='campaign_type']:checked").trigger("focus");
		else
			$("input[name='campaign_type']:first").trigger("focus");
		
		
		$(".theme_change_activator").change(function()
		{
			var parent = $(this).parents(".digits_examples");
			var theme = $(this).val();

			var themeParams = MegaTicker.themes[theme];
			themeSet(themeParams);

		});
		$(".theme_change_activator:checked").trigger("change");
		
		
		
	}); // ready
})(jQuery);
