<?php

	// A function to get an integer from everywhere in a string (concatenated or not).
	// http://de.php.net/intval
	if (!function_exists("str2int"))
	{
		function str2int($string) {
			return preg_replace("/[^0-9]/","", $string); 
		}
	}


	
/**
 * Get Filenames
 *
 * Reads the specified directory and builds an array containing the filenames.
 * Any sub-folders contained within the specified path are read as well.
 *
 * @access	public
 * @param	string	path to source
 * @param	bool	whether to include the path as part of the filename
 * @param	bool	internal variable to determine recursion status - do not use in calls
 * @return	array
 */
if ( ! function_exists('get_filenames'))
{
	function get_filenames($source_dir, $include_path = FALSE, $_recursion = FALSE)
	{
		static $_filedata = array();

		if ($fp = @opendir($source_dir))
		{
			// reset the array and make sure $source_dir has a trailing slash on the initial call
			if ($_recursion === FALSE)
			{
				$_filedata = array();
				$source_dir = rtrim(realpath($source_dir), DIRECTORY_SEPARATOR).DIRECTORY_SEPARATOR;
			}

			while (FALSE !== ($file = readdir($fp)))
			{
				if (@is_dir($source_dir.$file) && strncmp($file, '.', 1) !== 0)
				{
					get_filenames($source_dir.$file.DIRECTORY_SEPARATOR, $include_path, TRUE);
				}
				elseif (strncmp($file, '.', 1) !== 0)
				{
					$_filedata[] = ($include_path == TRUE) ? $source_dir.$file : $file;
				}
			}
			return $_filedata;
		}
		else
		{
			return FALSE;
		}
	}
}


// fetch youtube's video id
if ( ! function_exists('megaticker_get_youtube_id'))
{
	function megaticker_get_youtube_id($url)
	{
		if (!stristr($url,'embed'))
		{
			if (parse_url($url, PHP_URL_HOST) == 'youtu.be')
			{
				$videoId = str_replace('/','',parse_url($url, PHP_URL_PATH));
				
			}
			else
			{
				$url = parse_url($url, PHP_URL_QUERY);
				parse_str($url, $url_params);
				$videoId = $url_params['v'];
			}
			
			if ($videoId)
				return 'http://www.youtube.com/embed/'.sanitize_text_field($videoId);
		}
		
		return '';
	}
}


// fetch youtube's video id
if ( ! function_exists('megaticker_get_time_from_seconds'))
{
	function megaticker_get_time_from_seconds($seconds)
	{
		$hours = floor($seconds / (60 * 60));
		$seconds = $seconds - $hours * (60 * 60);
		$minutes = floor($seconds / (60));
		$seconds = $seconds - $minutes * 60;
		return sprintf('%02d',$hours).':'.sprintf('%02d',$minutes).':'.sprintf('%02d',$seconds);
	}
}