<?php if (!defined('WPINC')) die();
/*
	Plugin Name: MegaTicker
	Plugin URI: http://www.web-empires.ru/ticker/
	Description: Create a time-limited offers, adding countdown timers on your pages/posts. Use a sense of urgency and blow up the conversion! 
	Version: 1.0.2
	Author: Web-Empires.ru, AntonGorodezkiy
	Author URI: http://web-empires.ru/
	License: GNU GPL 2
	Text Domain: megaticker
*/

/*
	error_reporting(E_ALL);
	ini_set('display_errors',1);
*/


define('MEGATICKER_APPPATH',dirname(__FILE__));
define('MEGATICKER_VERSION','1.0.1');

if (get_option('megaticker__activation_code'))
	define('MEGATICKER_EDITION','PRO');
else
	define('MEGATICKER_EDITION','FREE');

define('MEGATICKER_SHOP_SITE','http://bronezhiletka.ru/');

$megatickerLoaded = array(
	'megaticker_add_front_js_files' => false,
	'megaticker_front_register_head' => false
);

define('MTSS_RECIVER', MEGATICKER_SHOP_SITE.'wp-content/plugins/megaticker-shop/registration.receiver.php');

if (!session_id())
	session_start();


// Create Text Domain For Translations
	function megatickerLocalization() {
		load_plugin_textdomain('megaticker', false, dirname( plugin_basename( __FILE__ ) ) . '/languages/'.get_locale().'/' );
	}
	add_action('wp_loaded', 'megatickerLocalization');
		
	
/* Models */
	include_once(MEGATICKER_APPPATH.'/models/megaticker_model.php');
	$campaigns = new Megaticker_model('megaticker_campaigns');
	$splashes = new Megaticker_model('megaticker_splashes');
	$counters = new Megaticker_model('megaticker_counters');
	
// includes
	include_once(MEGATICKER_APPPATH.'/libraries/time.ticker.class.php');
	include_once(MEGATICKER_APPPATH.'/libraries/functions.php');
	include_once(MEGATICKER_APPPATH.'/libraries/form_saver.megaticker.php');

/* Notify */
	if(!class_exists('Notify')) {
		include_once(MEGATICKER_APPPATH.'/libraries/notify.class.php');
		$notify = new Notify(array('ttl' => 4));
	}

/* installation */
	include_once(MEGATICKER_APPPATH.'/install.megaticker.php');
	register_activation_hook(__FILE__, 'installMegaTicker');
	register_deactivation_hook(__FILE__, 'uninstallMegaTicker');
	
	
/* styles and scripts */
	include_once(MEGATICKER_APPPATH.'/assets.megaticker.php');
	if (is_admin())
	{
		add_action('admin_enqueue_scripts', 'megaticker_admin_enqueue_scripts');
	}
	else
	{
		add_action('wp_enqueue_scripts', 'megaticker_front_register_head');
		add_action('wp_enqueue_scripts','megaticker_add_front_js_files');	
	}


/* shortcode */

	// redirects must goes before shortcodes, so we'll fetch them from post content
		include_once(MEGATICKER_APPPATH.'/controllers/megaticker.php');
	
	// redirects must goes before shortcodes, so we'll fetch them from post content
		add_action('template_redirect', 'checkMegaTickerRedirects');
	
	// and after redirects checking, we'll show the shortcode 
		add_shortcode('MegaTickerShortcode', 'showMegaTicker');


	
if (is_admin())
{
	
/* editor */
	include_once(MEGATICKER_APPPATH.'/editor.megaticker.php');
	add_action('init', 'megatickerAddButtons');
	
/* admin menu */
	add_action( 'admin_menu', 'register_megaticker_menu_page' );
	function register_megaticker_menu_page()
	{
		
		global $megaticker_hooks;
	
		$megaticker_hooks[] = add_utility_page('MegaTicker '.MEGATICKER_EDITION, 'MegaTicker '.MEGATICKER_EDITION, 'publish_posts', 'megaticker/megaticker.php', 'campaigns', get_option('siteurl')."/wp-content/plugins/megaticker/img/ticker.png");
		
		$megaticker_hooks[] = add_submenu_page( 'megaticker/megaticker.php', __('Campaigns', 'megaticker'), __('Campaigns', 'megaticker'), 'publish_posts', 'megaticker/megaticker.php', 'campaigns' );
		$megaticker_hooks[] = add_submenu_page( 'megaticker/megaticker.php', __('Add Campaign', 'megaticker'), __('Add Campaign', 'megaticker'), 'publish_posts', 'megaticker/megaticker.php?setup_campaign', 'setupCampaign' );
		
		$megaticker_hooks[] = add_submenu_page( 'megaticker/megaticker.php', __('Splashes', 'megaticker'), __('Splashes', 'megaticker'), 'publish_posts', 'megaticker/megaticker.php?splashes', 'splashes' );
		$megaticker_hooks[] = add_submenu_page( 'megaticker/megaticker.php', __('Add Splash', 'megaticker'), __('Add Splash', 'megaticker'), 'publish_posts', 'megaticker/megaticker.php?setup_splash', 'setupSplash' );
		
		$megaticker_hooks[] = add_submenu_page( 'megaticker/megaticker.php', __('Counters', 'megaticker'), __('Counters', 'megaticker'), 'publish_posts', 'megaticker/megaticker.php?counters', 'counters' );
		$megaticker_hooks[] = add_submenu_page( 'megaticker/megaticker.php', __('Add Counter', 'megaticker'), __('Add Counter', 'megaticker'), 'publish_posts', 'megaticker/megaticker.php?setup_counter', 'setupCounter' );
	
		if (MEGATICKER_EDITION == 'FREE')
		{
			$megaticker_hooks[] = add_submenu_page( 'megaticker/megaticker.php', __('Registration', 'megaticker'), __('Registration', 'megaticker'), 'publish_posts', 'megaticker/megaticker.php?registration', 'showRegistration' );
		}
	}
	
/* including controllers */
	include_once(MEGATICKER_APPPATH.'/controllers/campaigns.php');
	include_once(MEGATICKER_APPPATH.'/controllers/splashes.php');
	include_once(MEGATICKER_APPPATH.'/controllers/counters.php');
	include_once(MEGATICKER_APPPATH.'/controllers/registration.php');
	
// routing
	if (isset($_REQUEST['action']))
	{
		switch($_REQUEST['action'])
		{
			case 'save_campaign':
				add_action('wp_loaded','saveCampaign');
			break;
			
			case 'copy_campaign':
				add_action('wp_loaded','copyCampaign');
			break;
			
			case 'delete_campaign':
				add_action('wp_loaded','deleteCampaign');
			break;
			
			
			case 'save_splash':
				add_action('wp_loaded','saveSplash');
			break;
			
			case 'delete_splash':
				add_action('wp_loaded','deleteSplash');
			break;
			
			
			case 'save_counter':
				add_action('wp_loaded','saveCounter');
			break;
			
			case 'copy_counter':
				add_action('wp_loaded','copyCounter');
			break;
			
			case 'delete_counter':
				add_action('wp_loaded','deleteCounter');
			break;
		
			case 'registration':
				add_action('wp_loaded', 'megatickerRegistration');
			break;
		}
	}
		
// more routing
	if (isset($_REQUEST['action2']))
	{
		switch($_REQUEST['action2'])
		{
			case 'delete_campaign':
				add_action('wp_loaded','deleteCampaign');
			break;
		
			case 'delete_splash':
				add_action('wp_loaded','deleteSplash');
			break;
		
			case 'delete_counter':
				add_action('wp_loaded','deleteCounter');
			break;
		}
	}

}

